/* Convert AFOEF to BAV
	TL, 10.06.2001
	01.01.2002: for AFOEV data file from ftp-server, option "-d"
	24.02.2002: conversion list in file obsafoev.lst
*/

#include "stdlib.h"
#include "stdio.h"
#include "string.h"

int OBSPOS = 34;

int  convertN = 0;
char convertAFOEV[100][5];
char convertAAVSO[100][5];
int  convertStore[100];

int ReadObsCodeConversionList( const char* filename )
{
	char line[128];
	FILE* f = fopen(filename,"r");
	if (f==NULL)	return 0;
	
	convertN = 0;
	while (fgets(line,sizeof(line)-1,f)) 
	{
		int ok;
		char* ptr = strchr(line,'#');
		if (ptr)	*ptr = 0;
		ptr = strchr(line,';');
		if (ptr)	*ptr = 0;
		convertStore[convertN] = 1;
		ok = sscanf(line,"%s %s %i",convertAFOEV[convertN],convertAAVSO[convertN],&convertStore[convertN]);
		if (ok>=2) 
		{
//			fprintf(stderr,"%s --> %s: %i\n",convertAFOEV[convertN],convertAAVSO[convertN],convertStore[convertN]);
			convertN++;		
		}
	}
	
	fclose(f);
	return convertN;
}

int main (int argc, char *argv[])
{
	char line[512];
	char obslist[100][4];	
	int  obscount[100]; 
	int  obsN = 0;
	FILE *fIn = stdin, *fOut = stdout;
	int argFile = 1;
	int isFtpData = 0;
	
	if (argc<2) 
	{
		fprintf(stderr,"convert_afoev [-d] <fileIn> <fileOut>\n TL 01.01.2002\n");
		return 0;
	}

	ReadObsCodeConversionList("/home/trl/varstar/varstar/obsafoev.lst");
	
	if (argc>=2) 
	{
		if (argv[1][0]=='-' && argv[1][1]=='d') 
		{
			isFtpData = 1;
			argFile = 2;
			OBSPOS = 0;
		}
		fIn = fopen(argv[argFile],"r");
		if (fIn==NULL)	
			fIn = stdin;
	}
	if (argc>=argFile+2) 
	{
		fOut = fopen(argv[argFile+1],"w");
		if (fOut==NULL)	
			fOut = stdout;
	}
	if (isFtpData)
		fprintf(fOut,"ooooooooo dddddddddd lmmmm A\n");
	else
		fprintf(fOut,"              nnnnnnnnn           ooodddddddddd lmmmm\n");

	while (fgets(line,sizeof(line),fIn)) 
	{
		int store = 0;
		int isAFOEV = 1;
		if (strlen(line)>50 || isFtpData) 
		{
			char obs[4];
			int checkI;
			store = 1;
			strncpy(obs,line+OBSPOS,3);	obs[3] = 0;
			for (checkI=0; checkI<convertN; checkI++) 
			{
				if (strcmp(obs,convertAFOEV[checkI])==0) 
				{
					strcpy(obs,convertAAVSO[checkI]);
					store = convertStore[checkI];
					isAFOEV = 0;
				}
			}
			line[OBSPOS  ] = obs[0];
			line[OBSPOS+1] = obs[1];
			line[OBSPOS+2] = obs[2];
		}
		if (store) 
		{
			char obs[4];
			int i;
			strncpy(obs,line+OBSPOS,3);	obs[3] = 0;
			for (i=0; i<obsN; i++)
				if (strcmp(obs,obslist[i])==0) 
				{
					obscount[i]++;
					break;
				}
			if (i==obsN) 
			{
				strcpy(obslist[obsN],obs);
				obscount[obsN] = 1;
				obsN++;
			}
			if (isFtpData) 
			{
				fprintf(fOut,obs);
				fprintf(fOut, isAFOEV ? ".AFOEV " : "       " );
				fprintf(fOut,line+3);
			}
			else
			{
				fprintf(fOut,line);
			}
		}
	}
	
	if (fIn!=stdin)
		fclose(fIn);
	if (fOut!=stdout)
		fclose(fOut);
	while (obsN>0) {
		obsN--;
		fprintf(stdout,"%s %4i\n",obslist[obsN],obscount[obsN]);
	}
	return 0;
}
