// TL 28.02.2002 & 02.03.2002
// TL 05.05.2005: Option -a fuer Listen von BHA

#include "stdlib.h"
#include "stdio.h"
#include "string.h"
#include <ctype.h>


int main (int argc, char *argv[])
{
	int argI = 1;
	int isAavsoKomma = 0;
	char line[512];
	FILE *fIn = stdin, *fOut = stdout;
	char str[128], datum[20], observer[10];
	strcpy(observer,"KIS");
	
	if (argc<2) 
	{
		fprintf(stderr,"kis2vsnet [-a] [-o Code] <fileIn> <fileOut>\n");
		fprintf(stderr,"             : erzeuge aus Liste 'Stern Zeit Hell' mit 'D=mmtt' ein VSNET Format\n");
		fprintf(stderr,"           -o Code: Beobachterkuerzel (Standard: KIS)\n");
		fprintf(stderr,"           -a: konvertiere ',' nach '.' in AAVSO Format\n");
		fprintf(stderr," TL 28.02.2002 & 05.05.2005\n");
		return 0;
	}

	while (argv[argI][0]=='-')
	{
		switch (argv[argI][1])
		{
			case 'a':
				isAavsoKomma = 1;
				break;
			case 'o':
				argI++;
				strcpy(observer,argv[argI]);
				break;
		}
		argI++;
	}
	if (argI<argc) 
	{
		fIn = fopen(argv[argI],"r");
		if (fIn==NULL)	
			fIn = stdin;
		argI++;
	}
	if (argI<argc) 
	{
		fOut = fopen(argv[argI],"w");
		if (fOut==NULL)	
			fOut = stdout;
		argI++;
	}

	datum[0] = 0;
	while (fgets(line,sizeof(line),fIn)) 
	{
		if (isAavsoKomma)	
		{
			if (strlen(line)>50 && isdigit(line[0]) && isdigit(line[5]) && (line[4]=='-' || line[4]=='+'))
			{
				if (line[25]==',')	line[25] = '.';
				if (line[33]==',')	line[33] = '.';
				if (line[34]==',')	line[34] = '.';
			}
			fprintf(fOut,line);
		}
		else
		if (line[0]=='D' && line[1]=='=') 
		{
			strncpy(datum,line+2,4);
			datum[4] = 0;
		}
		else 
		if (line[0]!=0) 
		{
			char* ptr = line;
			int hell = -9999;
			int kleiner = 0;
			float zeit = -1;
			while ((ptr=strstr(line,"=09"))!=NULL)
			{	*ptr=' '; *(ptr+1)=' '; *(ptr+2)=' '; }
			ptr = line;
			/* Sternname */
			while (*ptr==' ')	ptr++;
			while (*ptr!=' ')	ptr++;
			while (*ptr==' ')	ptr++;
			while (*ptr!=' ')	ptr++;
			*ptr = 0;	ptr++;
			/* Zeit in UT */
			while (*ptr==' ')	ptr++;
			zeit = atof(ptr);
			while (*ptr!=' ')	ptr++;
			while (*ptr==' ')	ptr++;
			/* Helligkeit */
			if (*ptr=='<') 
			{
				kleiner = 1;
				ptr++;
			}
			hell = atoi(ptr);
			/* VSNET-Format erzeugen */
			sprintf(str,"%3.3f",zeit/24.0);
			fprintf(fOut,"%s   %s%s   %s%i   %s\n",line,datum,str+1,(kleiner?"<":""),hell,observer);
		}
	}
	
	if (fIn!=stdin)
		fclose(fIn);
	if (fOut!=stdout)
		fclose(fOut);
	return 0;
}

