
#include <stdlib.h>
#include <stdio.h>
#include "libtl_string.h"


/******************************************************************************
*       Strings                                                               *
******************************************************************************/

tstring strn0cpy (char *d, const char *s, int len) 
{ 
	strncpy(d,s,len); 
	d[len] = '\0';
	return d;
}

tstring strn0cpy_space (char *d, const char *s, int len) 
{ 
	unsigned char *c, *empty; 
	int i;
	for (i=len; i>=0; i--)
		d[i] = s[i];
	d[len] = '\0'; 
	c = d;
	empty = NULL;
	while (*c>=' ') 
	{
		if (*c>' ')
			empty = c+1;
		c++;
	}
	*c = '\0';
	if (empty!=NULL)
		*empty = '\0';
	while (d[0]==' ') 
		memmove(d,d+1,len);
	return d;
}

void sec_gets_80( char* str )
{
	char *ptr;
	str[0] = '\0';
	fgets(str,79,stdin);
	ptr = strchr(str,'\n');
	if (ptr)	*ptr = '\0';
}

tstring fgetline (char *s, int len, FILE *f)
{
  int  i = 0;
  int  c = fgetc(f);
  while ((c!=(int)'\n') && (c>=0)) {
    if (c==(int)'\r') {
      s[i] = '\0';
      i=len;
    }
    if (i<len) {
      s[i++] = (unsigned char)c;
      if (i==len) s[i-1] = '\0';
    }
    c = fgetc(f);
  }
  if (i<len)
    s[i] = '\0';
//fprintf(stderr,"fgetline %i '%s'\n",strlen(s),s); 
  if (c<0) return NULL;
  else     return s;
}


tstring toupperstr (tstring s)
{
	int i=0;
	while (s[i]!='\0') { s[i] = toupper(s[i]); i++; }
	return s;
}

tstring tolowerstr (tstring s)
{
	int i=0;
	while (s[i]!='\0') { s[i] = tolower(s[i]); i++; }
	return s;
}

tstring deletestr (tstring str, int pos, int del)
{
	while (str[pos+del]!=(char)0) 
	{
		str[pos] = str[pos+del];
		pos++;
	}
	str[pos] = (char)0;
	return str;
}

tstring insertstr (tstring ins, tstring str, int pos)
{
	char s[256];
	if (pos==0)
		sprintf(s,"%s%s",ins,str);
	else
		sprintf(s,"%.*s%s%s",pos,str,ins,str+pos);
	strcpy(str,s);
	return str;
}


tstring replacestrallchr (tstring str, char oldChar, char newChar)
{
	char* ptr = str;
	while (*ptr!=0) 
	{
		if (*ptr==oldChar)
			*ptr = newChar;
		ptr++;
	}
	return str;
}


tstring replaceStrByStr (tstring str, tstring oldStr, tstring newStr)
{
	char *ptr;
	int oldlen = strlen(oldStr);
	while ((ptr = strstr(str,oldStr))!=NULL)
	{
		int pos = ptr-str;
		deletestr(str, pos, oldlen);
		insertstr(newStr, str, pos);
	}
	return str;
}

 
tstring ConvertDosChars( tstring zeile )
{
	char* ptr = zeile;
	while (*ptr) {
		switch (*ptr) {
		case -124:	*ptr = '';	break;
		case -114:	*ptr = '';	break;
		case -108:	*ptr = '';	break;
		case -103:	*ptr = '';	break;
		case -127:	*ptr = '';	break;
		case -98:
		case -31:	*ptr = '';	break;
		case -8:		*ptr = '';	break;
		case -80:	break;	// 
		}
		ptr++;
	}
	return zeile;
}


tstring NewString( const char *str )
{
	void *ptr = malloc( strlen(str)+1 );
	strcpy(ptr,str);
	return ptr;
}

void DeleteString( tstring *src )
{
	if (*src)
		free(*src);
	*src = NULL;
}

tstring SetString( tstring *dest, const char *src, int len )
{
	char *ptr;
	if (len==0 && src) 
		len = strlen(src);
	ptr = (char*)malloc(len+1);
	free(*dest);
	if (src)	
		strn0cpy(ptr,(char*)src,len);
	else
		ptr[len] = 0;
	*dest = ptr;
	return ptr;
}

tstring SetStrings( tstring *dest, const char *src1, const char* src2 )
{
  	int len = strlen(src1) + strlen(src2) +1;
  	char* ptr = (char*)malloc(len);
	free(*dest);
  	sprintf( ptr, "%s%s", src1, src2 );
	*dest = ptr;
	return ptr;
	
}

tstring AddString( tstring *dest, const char *add )
{
	char *ptr;
	if (add==NULL)
		return *dest;
	if (*dest==NULL) 
	{
		ptr = NewString(add);
	} 
	else 
	{	
		int len = strlen(*dest) + strlen(add) +1;
		ptr = (char*)malloc(len);
		sprintf( ptr, "%s%s", *dest, add );
		free(*dest);
	}
	*dest = ptr;
	return ptr;
}

tstring AddStrings( tstring *dest, const char *add1, const char *add2 )
{
	char *ptr;
	if (add1==NULL)
		return *dest;
	if (*dest==NULL) 
	{
		ptr = SetStrings(dest,add1,add2);
	} 
	else
	if (add2==NULL)
	{
		int len = strlen(*dest) + strlen(add1) + 1;
		ptr = (char*)malloc(len);
		sprintf( ptr, "%s%s", *dest, add1 );
		free(*dest);
	}
	else 
	{	
		int len = strlen(*dest) + strlen(add1) + strlen(add2) +1;
		ptr = (char*)malloc(len);
		sprintf( ptr, "%s%s%s", *dest, add1, add2 );
		free(*dest);
	}
	*dest = ptr;
	return ptr;
}

void WritelnString( tstring *src, FILE* f )
{
   if (*src!=NULL) 
      fprintf(f,"%s\n",*src);
   else
      fprintf(f,"\n");
}

tstring ReadlnString ( tstring *dest, FILE* f )
{
	char zeile[256];
	if (fgetline(zeile,sizeof(zeile),f))
		SetString( dest, zeile, 0 );
	else
		SetString( dest, "", 0 );
	return *dest;
}

