
#include "stdlib.h"
#include "string.h"

#include "vs_forms.h"
#include "vs_sub.h"
#include "vs_main.h"
#include "vs_file.h"
#include "vs_ausgabe.h"
#include "vs_graph.h"
#include "vs_extrem.h"
#include "vs_chart.h"
#include "vs_beob.h"
#include "vs_sonne.h"
#include "vs_daten.h"
#include "vs_language.h"
#include "vs_ver.h"

#include "libtl/libtl_picture.h"
#include "libtl/libtl_draw.h"

FD_help          *fd_help;
FD_einstellungen *fd_einstellungen;

char              pfadRC[256];

/****************************************************************************/
/* Einstellungen                                                            */
/****************************************************************************/

void Einstellungen()
{
	char text[64];
	if (fd_einstellungen==NULL) 
	{
		fd_einstellungen = create_form_einstellungen();
		fl_addto_choice(fd_einstellungen->datum_modus, LS(240) );
		fl_addto_choice(fd_einstellungen->datum_modus, LS(241) );
		fl_addto_choice(fd_einstellungen->datum_modus, LS(242) );
		fl_addto_choice(fd_einstellungen->zeitzone,"UT");
		fl_addto_choice(fd_einstellungen->zeitzone,"MEZ");
		fl_addto_choice(fd_einstellungen->zeitzone,"MESZ");
		fl_addto_choice(fd_einstellungen->zeitmodus, LS(243) );
		fl_addto_choice(fd_einstellungen->zeitmodus, LS(244) );
		fl_addto_choice(fd_einstellungen->zeitmodus, LS(245) );
		fl_addto_choice(fd_einstellungen->grafikFormat,"GIF");
		fl_addto_choice(fd_einstellungen->grafikFormat,"BMP");
		fl_addto_choice(fd_einstellungen->grafikFormat,"PPM");
		fl_addto_choice(fd_einstellungen->grafikFormat,"PS");
		fl_set_object_label(fd_einstellungen->sicht_unbekannt, LS(51) );
		fl_set_object_label(fd_einstellungen->sicht_visuell, LS(52) );
		fl_set_object_label(fd_einstellungen->sicht_photogr, LS(53) );
		fl_set_object_label(fd_einstellungen->negativ_beob, LS(54) );
		fl_set_object_label(fd_einstellungen->theoret_lk, LS(55) );
		fl_set_object_label(fd_einstellungen->datum_von, LS(56) );
		fl_set_object_label(fd_einstellungen->datum_bis, LS(57) );
		fl_set_object_label(fd_einstellungen->datum, LS(58) );
		fl_set_object_label(fd_einstellungen->zeitzone, LS(60) );
		fl_set_object_label(fd_einstellungen->zeitmodus, LS(61) );
		fl_set_object_label(fd_einstellungen->grafikX, LS(62) );
		fl_set_object_label(fd_einstellungen->grafikFormat, LS(63) );
		fl_set_object_label(fd_einstellungen->Close, LS_OK );
		fl_set_object_label(fd_einstellungen->Apply, LS_Apply );
	}

	fl_set_button(fd_einstellungen->sicht_unbekannt,(besArt & 1)==1);
	fl_set_button(fd_einstellungen->sicht_visuell  ,(besArt & 2)==2);
	fl_set_button(fd_einstellungen->sicht_photogr  ,(besArt & 4)==4);
	fl_set_button(fd_einstellungen->negativ_beob   ,mitNegativBeob);
	fl_set_button(fd_einstellungen->theoret_lk     ,mitTheoretKurve);
	JulDat2Zeit(besDatumVon,text);
	fl_set_input(fd_einstellungen->datum_von,text);
	JulDat2Zeit(besDatumBis,text);
	fl_set_input(fd_einstellungen->datum_bis,text);
	fl_set_input(fd_einstellungen->datum,useDateStr);
	fl_set_choice(fd_einstellungen->datum_modus,useDateMode+1);
	fl_set_choice(fd_einstellungen->zeitzone ,JulDatZone+1);
	fl_set_choice(fd_einstellungen->zeitmodus,formDatum+1);
	sprintf(text,"%i",grafikDruckX);
	fl_set_input(fd_einstellungen->grafikX,text);
	sprintf(text,"%i",grafikDruckY);
	fl_set_input(fd_einstellungen->grafikY,text);
	fl_set_choice(fd_einstellungen->grafikFormat,grafikDruckFormat+1);
	fl_show_form(fd_einstellungen->einstellungen,FL_PLACE_MOUSE,FL_FULLBORDER, LS(50) );
	fl_raise_form(fd_einstellungen->einstellungen);
}

void cb_Einstellungen(FL_OBJECT *ob, long data)
{
	switch (data) {
	case 1:
		besArt ^= 1;
		break;
	case 2:
		besArt ^= 2;
		break;
	case 3:
		besArt ^= 4;
		break;
	case 10:
		mitNegativBeob = !mitNegativBeob;
		break;
	case 11:
		mitTheoretKurve = !mitTheoretKurve;
		break;
	case 20:
	{	char s[30];
		strncpy(s,fl_get_input(fd_einstellungen->datum_von),30);
		besDatumVon = Zeit2JulDat(s);
		break;
	}
	case 21:
	{	char s[30];
		strncpy(s,fl_get_input(fd_einstellungen->datum_bis),30);
		besDatumBis = Zeit2JulDat(s);
		break;
	}
	case 22:
		strncpy(useDateStr, fl_get_input(fd_einstellungen->datum) ,sizeof(useDateStr));
		break;
	case 23:
		useDateMode = fl_get_choice(fd_einstellungen->datum_modus)-1;
		break;
	case 24:
		JulDatZone = fl_get_choice(fd_einstellungen->zeitzone)-1;
		break;
	case 25:
		formDatum = fl_get_choice(fd_einstellungen->zeitmodus)-1;
		break;
	case 30:
		grafikDruckX = atoi(fl_get_input(fd_einstellungen->grafikX));
		if (grafikDruckX< 100) grafikDruckX =  100;
		if (grafikDruckX>1600) grafikDruckX = 1600;
		draw_setup_size( grafikDruckX, grafikDruckY );
		break;
	case 31:
		grafikDruckY = atoi(fl_get_input(fd_einstellungen->grafikY));
		if (grafikDruckY< 100) grafikDruckY =  100;
		if (grafikDruckY>1200) grafikDruckY = 1200;
		draw_setup_size( grafikDruckX, grafikDruckY );
		break;
	case 32:
		grafikDruckFormat = fl_get_choice(fd_einstellungen->grafikFormat)-1;
		break;
	case 99: /* Close */
		fl_hide_form(fd_einstellungen->einstellungen);
	case 98: /* Apply */
		Daten_Text();
		break;
	}
}

/****************************************************************************/
/* Hilfe-Fenster                                                            */
/****************************************************************************/

void cb_Help(FL_OBJECT *ob, long data)
{
	fl_hide_form(fd_help->help);
}

void OpenHelp( const char *titel, const char **text )
{
	int i;
	if (fd_help==NULL) {
		fd_help = create_form_help();
	}
	fl_clear_browser(fd_help->text);
	for (i=0; text[i]!=NULL; i++) 
		fl_addto_browser(fd_help->text,text[i]);
	fl_show_form(fd_help->help,FL_PLACE_MOUSE,FL_FULLBORDER,titel);
	fl_raise_form(fd_help->help);
}

/****************************************************************************/
/* Menu und Shortcuts                                                       */
/****************************************************************************/

void cb_pd_shortcut(FL_OBJECT *ob, long data)
{
	const XEvent *xe;
	xe = fl_last_event();
/*
fprintf(stdout,"shortcut type=%i state=%i keycode=%i sum=%i\n",
        xe->type,xe->xkey.state,xe->xkey.keycode,xe->xkey.state*256+xe->xkey.keycode);
*/
	if (xe->type==3) 
	{
		switch (xe->xkey.state*256+xe->xkey.keycode) {
		case 67:   /* F1 */
			ShowInfo(FALSE);
			break;
		case 96:   /* F12 */
			Chart_Graph();
			break;
		case 2094: /* #L */
		case 1070: /* ^L */
			Daten_Laden(); 
			break;
		case 2087: /* #S */
		case 1063: /* ^S */
			Daten_Speichern();
			break;
		case 2072: /* #Q */
		case 1048: /* ^Q */
			exit(1);
			break;
		//case 2094: /* #L */
		//	Beob_Liste();
		//	break;
		case 2104: /* #B */
		case 1080: /* ^B */
			Beob_Edit(NULL);
			break;
		case 2103: /* #V */
		case 1079: /* ^V */
			Beob_VSNET();
			break;    
		case 2081: /* #P */
		case 1057: /* ^P */
			HellPhase();
			break;    
		case 2091: /* #H */
		case 1067: /* ^H */
			HellKurve();
			break;    
		case 2074: /* #E */
		case 1050: /* ^E */
			Einstellungen();
			break;    
		case 2076: /* #T */
		case 1052: /* ^T */
			VSNET_Tag();
			break;
		case 2093: /* #K */
		case 1069: /* ^K */
			BAV_HellKurve();
			break;
		case 2079: /* #I */
		case 1055: /* ^I */
			Erzeugung_MaximaListe();
			break; 	 
		}
	}
}

void cb_pd_file(FL_OBJECT *ob, long data)
{
	switch (fl_get_menu(fd_vs->pd_file)) {
	case 1: 
		ShowInfo(FALSE);
		break;
	case 3:
		Daten_GCVS(); 
		break;
	case 4:
		Daten_Laden(); 
		break;
	case 5:  
		Daten_Speichern(); 
		break;
	case 7:
		Chart_Graph();
		break;
	case 9: 
		exit(1);
	}  
	LowerMainForm();
}

void cb_pd_beobachtungen(FL_OBJECT *ob, long data)
{
   switch (fl_get_menu(fd_vs->pd_beobachtungen)) {
   case 1: 
      if (diskLoad==diskFirst)
         Sonne_Liste(TRUE);
      else 
         Beob_Liste();
      break;
   case 2:
      if (diskLoad==diskFirst)
         Script_Sonne_Neu(NULL);
      else
         Beob_Edit(NULL);
      break;  
   case 3:
      Observer_Edit(NULL);
      break;     
	case 4:
		Beob_Statistics();
		break;
	case 6: 
      Beob_VSNET();
      break;
   case 7:
      Beob_AFOEV();
      break;
   case 8:
      Beob_AAVSO();
      break;
   case 9:
   	ExportAveragedData();
   	break;
   } 
}
  
void cb_pd_auswertung(FL_OBJECT *ob, long data)
{
	switch (fl_get_menu(fd_vs->pd_auswertung)) {
	case 1: 
		HellPhase(); 
		break;
	case 2: 
		HellKurve();
		break;
	case 3:
		ExtremGraphShow();
		break;	
	case 4: 
		SternTypTest();
		break;
	case 5:
		Analyse(); 
		break; 
	case 7: 
		Einstellungen();
		break;
	}
}    

void cb_pd_meldungen(FL_OBJECT *ob, long data)
{
	switch (fl_get_menu(fd_vs->pd_meldungen)) {
	case 1: 
		Erzeugung_Stern_HTML(FALSE,"");
		break;
	case 2: 
		VSNET_Einzelstern(TRUE);
		break;
	case 3: 
		VSNET_Einzelstern(FALSE);
		break;
	case 5: 
		VSNET_Tag(); 
		break;
	case 6: 
		Monatsliste(); 
		break;
	case 7: 
		BAV_HellKurve(); 
		break;
	case 8: 
		Erzeugung_MaximaListe(); 
		break;
	case 9: 
		AllStarsStatistics(); 
		break;
	// nicht implementiert:
		//Maxima_Liste(); 
	}
}

/****************************************************************************/
/* main / exit / Script                                                     */
/****************************************************************************/

void ScriptWork (int argc, char *argv[])
{
	switch (scriptMode) {
	case SCRIPT_BEOB_NEU:
		Script_Beob_Neu(scriptArg);
		break;
	case SCRIPT_CHART:
		Script_Chart(argc,argv);
		break;
	case SCRIPT_GRAFIK:
		Script_HellKurve();
		break;
	case SCRIPT_MAX_LISTE:
		cb_Erzeugung_MaximaListe(NULL,-1);
		break;
	case SCRIPT_MONAT:
		cb_Monatsliste(NULL,-1);
		break;
	case SCRIPT_TAG:
		cb_VSNET_Tag(NULL,-1);
		break;
	case SCRIPT_VSNET:
		cb_Beob_VSNET(NULL,-1);
		break;
	case SCRIPT_BAV_DB:
		BAV_Datenbank_Erzeugung();
		break;
	case SCRIPT_HTML_STERN:
		Erzeugung_Stern_HTML(FALSE,"");
		break;
	default:
		// nix zu tun
		;
	}
}

void exit_vs()
{
	if (flagNeueDaten)
		Daten_Speichern_Neu();
	if (monatEinschubNeu || saveWinpos)
		Speichern_RC(pfadRC);
	DatenLoeschen();
	AliasLoeschen();
	if (observerChange)
		WriteObservers();
	DeleteObservers();
	DeleteOrganisation();
	fl_free_pixmap(icon_vs);
	fl_free_pixmap(icon_vs_mask);
}

#include <locale.h>

int main(int argc, char *argv[])
{
	strcpy(pfadStart,argv[0]);
	{	int i = strlen(pfadStart)-1;
		while ((i>=0) && (pfadStart[i]!='/')) i--;
		pfadStart[i+1] = '\0';
	}
	if (!Start(argc,argv,pfadRC))
		return 0;

	if (argc>1 && strcmp(argv[1],"-CONVERT")==0)
	{	
		_ChangeFileFormat(); 
		return 0;
	}

	atexit(exit_vs);

	scriptRun = (scriptMode!=SCRIPT_NO);
	if (scriptRun) 
	{
		ScriptWork(argc,argv);
		return 0;
	}  
	
	fl_initialize(&argc, argv, "varstars", 0, 0);
	fprintf( stderr, "%sSetLocale %s for decimal point '.'\n", VerError, setlocale(LC_NUMERIC,"en_US") );
	ShowMainForm();
  	Daten_Text();
  
  	if (autoScanVSNET && (pfadVSNET[0]!='\0')) 
  	{
  		Beob_VSNET();
  		cb_Beob_VSNET(NULL,1);
	}

	fl_do_forms();
  
	return 1;
}

