
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "libtl/cgi-util.h"

#include "vs_sub.h"
#include "vs_main.h"
#include "vs_file.h"
#include "vs_ausgabe.h"
#include "libtl/libtl_string.h"

#define MAX_ENTRIES 100

char pfadRC[256];

int myArgc = 0;
char *myArgv[100];

int   cgiN = 0;
entry cgiEntries[MAX_ENTRIES];

char* NewArg( const char* theArgument )
{
	if (theArgument)
	{
		int len = strlen(theArgument);
		char* arg = (char*)malloc(len+1);
		strcpy(arg,theArgument);
		myArgv[myArgc] = arg;
		myArgc++;
		return arg;
	}
	return NULL;
}


const char* FindEntry( const char* theName )
{
	int x;
	for (x=0; x<cgiN; x++)
	{
		if (strcmp(cgiEntries[x].name,theName)==0)
			return cgiEntries[x].val;
	}
	return NULL;
}


int Error( const char* theText )
{
	FILE* fHTML = stdout;
	AppendHTML( fHTML, "star_head.html", "<HTML>\n<HEAD>\n<TITLE>Star information</TITLE>\n</HEAD>\n<BODY>\n" );
	fprintf(fHTML,"<H2>Fehler</H2>\n");
	fprintf(fHTML,"<P>\n");
	fprintf(fHTML,theText);
	fprintf(fHTML,"\n");
	AppendHTML( fHTML, "star_tail.html", "</BODY>\n</HTML>\n" );
	return 1;
}


const char* AddValue( char* htmlPar, const char* entry, const char* vsName )
{
	const char* ptr = FindEntry(entry);
	if (ptr && strlen(ptr)<20)
	{	char addstr[128];
		sprintf(addstr,"%s=%s,",vsName,ptr);
		strcat(htmlPar,addstr);
	}
	return htmlPar;
}


const char* AddFormValue( char* htmlPar, const char* entryForm, const char* entryColor, const char* vsName )
{
	int mode = 0;
	const char* ptrForm  = FindEntry(entryForm);
	const char* ptrColor = FindEntry(entryColor);
	char addstr[128];
	if (ptrForm==NULL && ptrColor==NULL)
		return NULL;
	if (ptrColor)
	{
		strncpy(addstr,ptrColor,2);	addstr[2] = 0;
		addstr[0] = toupper(addstr[0]);
		addstr[1] = toupper(addstr[1]);
		if (strcmp(addstr,"RO")==0)	mode = 1;
		if (strcmp(addstr,"GE")==0)	mode = 2;
		if (strcmp(addstr,"BL")==0)	mode = 3;
		if (strcmp(addstr,"GR")==0)	mode = 4;
	}
	if (ptrForm)
	{
		strncpy(addstr,ptrForm,2);	addstr[2] = 0;
		addstr[0] = toupper(addstr[0]);
		addstr[1] = toupper(addstr[1]);
		if (strcmp(addstr,"KR")==0)	mode += 0;
		if (strcmp(addstr,"QU")==0)	mode += 5;
	}
	sprintf(addstr,"%s=%i,",vsName,mode);
	strcat(htmlPar,addstr);
	return htmlPar;
}


int main(int argc, char *argv[])
{
	int x;
	int cl;
	const char* envptr, *obssearchptr;
	char htmlPar[1024];

	printf("Content-type: text/html\n\n");

	envptr = getenv("REQUEST_METHOD");
//	if (envptr==NULL || strcmp(envptr,"POST"))
//		return Error("This script should be referenced with a METHOD of POST.\n");
	envptr = getenv("CONTENT_LENGTH");
	cl = (envptr ? atoi(envptr) : 0);

	if (envptr==NULL && argc>1)
	{	// TL 23.05.04: direkter Parameter aus HREF: 
		//              <prg>?name1:val1!name2:val2!...
		char *ptr = argv[1];
		char *ptr1, *ptr2;
		while (*ptr)
		{
			ptr1 = strchr(ptr,':');
			ptr2 = strchr(ptr,'!');
			if (ptr1 && ptr2 && ptr1<ptr2)
			{
				*ptr1 = 0;
				*ptr2 = 0;
				cgiEntries[cgiN].name = ptr;
				cgiEntries[cgiN].val  = ptr1+1;
				cgiN++;
			}
			ptr = (ptr2 ? ptr2+1 : NULL);
		}
	}
	else
	{
		for (x=0; cl && (!feof(stdin)); x++)
		{
			cgiN = x+1;
			cgiEntries[x].val = fmakeword(stdin,'&',&cl);
			plustospace(cgiEntries[x].val);
			unescape_url(cgiEntries[x].val);
			cgiEntries[x].name = makeword(cgiEntries[x].val,'=');
		}
	}

#	if 0
	printf("<H1>Query Results</H1>");
	printf("You submitted the following name/value pairs:<p>%c",10);
	printf("<ul>%c",10);

	for (x=0; x < cgiN; x++)
		printf("<li> <code>%s = %s</code>\n",cgiEntries[x].name,cgiEntries[x].val);
	printf("</ul>\n");
#	endif

	strcpy(pfadStart,argv[0]);
	{	int i = strlen(pfadStart)-1;
		while ((i>=0) && (pfadStart[i]!='/')) i--;
		pfadStart[i+1] = '\0';
	}

	// meine Argumente zusammenbasteln aus den cgiEntries
	NewArg(argv[0]);

	sprintf(htmlPar,"-SH");
	AddValue(htmlPar,"perioden","per");
	AddValue(htmlPar,"datum0","date0");
	AddValue(htmlPar,"datum1","date1");
	envptr = FindEntry("group");
	if (envptr)
	{	char str[32];
		int group = 0;
		if (strcmp(envptr,"BAV+VSNET")==0)	group = 3;
		if (strcmp(envptr,"BAV")==0)		group = 2;
		sprintf(str,"group=%i,",group);
		strcat(htmlPar,str);
	}
	AddFormValue(htmlPar,"group-form","group-color","groupform");
	AddValue(htmlPar,"obs1","obs1");
	AddFormValue(htmlPar,"obs1-form","obs1-color","obs1form");
	AddValue(htmlPar,"obs2","obs2");
	AddFormValue(htmlPar,"obs2-form","obs2-color","obs2form");
	AddValue(htmlPar,"obs3","obs3");
	AddFormValue(htmlPar,"obs3-form","obs3-color","obs3form");
	AddValue(htmlPar,"listobs","listobs");
	AddValue(htmlPar,"bmr","bmr");
	NewArg(htmlPar);

	// bearbeite diesen Stern
	obssearchptr = FindEntry("obssearch");
	envptr = FindEntry("stern");
	if (envptr==NULL && obssearchptr==NULL)
		return Error("Angabe eines Sterns fehlt!");
	if (envptr!=NULL)
	{
		if (strlen(envptr) > 31)
			return Error("Illegaler Sternname (Name zu lang)!");
		NewArg(envptr);
	}

	if (!Start(myArgc,myArgv,pfadRC))
		return Error("Error during startup of vs_html!");

	if (obssearchptr && strlen(obssearchptr)>0)
	{
		struct RObserver* obsPtr = observerFirst;
		FILE* fHTML = stdout;
		AppendHTML( fHTML, "star_head.html", "<HTML>\n<HEAD>\n<TITLE>Observer list</TITLE>\n</HEAD>\n<BODY>\n" );
		fprintf( fHTML, "<H2>Beobachtersuche nach '%s'</H2><P>\n", obssearchptr );
		fprintf( fHTML, "<UL>\n" );
		while (obsPtr)
		{
			if (strstr(obsPtr->name,obssearchptr))
				fprintf( fHTML, "<LI>%s: %s\n", obsPtr->code, obsPtr->name );
			obsPtr = obsPtr->next;
		}
		fprintf( fHTML, "</UL>\n" );
		AppendHTML( fHTML, "star_tail.html", "</BODY>\n</HTML>\n" );
		return 0;
	}

	envptr = FindEntry("stern");
	if (diskLoad==NULL && strlen(envptr)<4)
	{	// Sterne auflisten
		int len = strlen(envptr);
		struct RDisk *diskList = diskFirst;
		char test[4];
		strcpy(test,envptr);
		tolowerstr(test);
		while (diskList!=NULL)
		{
			if (strncmp(test,diskList->name,len)==0)
				printf("- %s<BR>\n",diskList->name);
			diskList = diskList->next;
		}
		return 0;
	}
	if (diskLoad==NULL)
	{
		// Alias des Sterns suchen
		struct RAlias* testAlias = aliasFirst;
		char parmName[32];
		strcpy(parmName,envptr);
		toupperstr(parmName);
		while (testAlias)
		{
			if (strcmp(testAlias->muster,parmName)==0)
			{
				Stern_Laden( testAlias->org );
			}
			testAlias = testAlias->next;
		}
		if (diskLoad==NULL)
			return Error("Stern nicht in der Datenbank enthalten!<BR>\nStar not found!");
	}

	scriptRun = (scriptMode!=SCRIPT_NO);
	switch (scriptMode) {
	case SCRIPT_NO:
		ShowInfo(TRUE);
		break;
	case SCRIPT_HTML_STERN:
		Erzeugung_Stern_HTML(TRUE,linkIMG);
		break;
	default:
		return Error("Illegal command to vs_html!");
	}

	return 0;
}

