
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "libtl/libtl_string.h"
#include "vs_sub.h"
#include "vs_sonne.h"


void Sun_RelZahl()
// Instrumenten- und ffnungsabhngige Korrektur der Relativzahl
{
	int    i;
	double k;
	struct RSonne *sonnePtr;

	for (i=0; i<=sehZahl; i++) 
	{
		seh_k[i]=0;
		seh_z[i]=0;
	}
	
	sonnePtr = sonneFirst;
	while (sonnePtr!=NULL) 
	{
		i = sonnePtr->seh;
		seh_z[i]++;
		if (sonnePtr->gruppe>0)
			seh_k[i] += sonnePtr->fleck/sonnePtr->gruppe;
		sonnePtr = sonnePtr->next;
	}
	
	k = 0.0;
	for (i=1; i<=sehZahl; i++) 
	{
		seh_k[i] /= seh_z[i];
		if (seh_k[i]>k) k=seh_k[i];
	}
	for (i=1; i<=sehZahl; i++)
		seh_k[i] = k/seh_k[i];
	
	sonnePtr = sonneFirst;
	while (sonnePtr!=NULL) 
	{
		sonnePtr->rel = 10*sonnePtr->gruppe+trunc(sonnePtr->fleck*seh_k[sonnePtr->seh]);
		sonnePtr = sonnePtr->next;
	}
}

void WriteSonneText()
{
	fprintf(stderr,"\n\nSonne\n");
	fprintf(stderr," Datum            Gruppen   Flecken   Relativzahl     Instrument\n");
}
      
void Sonne_Liste (bool alle)
{
	RSonne* sonnePtr;

	WriteSonneText();
	sonnePtr = sonneFirst;
	while (sonnePtr) {
		char str[64], line[128];
		ZeitDatum(sonnePtr->datum,line);
		strncat(line,SPACE,20-strlen(line));
		sprintf(str,"%4i      ",sonnePtr->gruppe);
		strcat(line,str);
		sprintf(str,"%4i      ",sonnePtr->fleck);
		strcat(line,str);
		sprintf(str,"(%3i) %3i", 10*sonnePtr->gruppe+sonnePtr->fleck, sonnePtr->rel );
		strcat(line,str);
		strncat(line,SPACE,56-strlen(line));
		strcat(line,seh_name[sonnePtr->seh]);
		fprintf(stderr,"%s\n",line);
		sonnePtr = sonnePtr->next;
	}
}

void Script_Sonne_Neu (char *arg)
{
	char 	str[128];
	RSonne *sunNew, *sonnePtr, *sunLast;

	printf("neue Sonnenbeobachtung\n");
	printf("Datum ? ");
	str[0] = '\0';
	sec_gets_80(str);
	if (strlen(str)>9) 
	{
		int instrument = 0;
		flagNeueDaten = TRUE;
		sunNew = (RSonne*) malloc(sizeof(RSonne));
		sonneZahl++;
		sunNew->datum = Zeit2JulDat(str);
		printf("Zahl der Gruppen: ");
		sec_gets_80(str);
		sunNew->gruppe = atoi(str);
		printf("Flecken: ");
		sec_gets_80(str);
		sunNew->fleck = atoi(str);
		printf("Beobachtungsinstrument\n");
		if (sehZahl>0) 
		{
      	int i;
      	for (i=1; i<=sehZahl; i++)
      		printf("   %i) %s\n",i,seh_name[i]);
      	printf("   0) Neueingabe\n");
      	printf(" Wahl? ");
			sec_gets_80(str);
			instrument = atoi(str);
			if (instrument>sehZahl)	
				instrument = 0;
      } else 
      	instrument = 0;
		if (instrument==0) 
		{
			printf("Neueingabe: Bezeichnung ? ");
			sehZahl++;
			sec_gets_80(str);
			strcpy(seh_name[sehZahl],str);
			instrument = sehZahl;
		}
      sunNew->seh = instrument;
      printf("\nEingabe:\n");
      printf(" Datum:  %s\n",ZeitDatum(sunNew->datum,str));
      printf(" Gruppen: %i\n",sunNew->gruppe);
      printf(" Flecken: %i\n",sunNew->fleck);
      printf(" %s\n",seh_name[sunNew->seh]);
      printf("Eingabe richtig (j/n) ?");
     	sec_gets_80(str);
		if (str[0]=='n') {
      	sonneZahl--; 
      	free(sunNew);
      } else {
			flagNeueDaten = TRUE;
			if (sonneFirst==NULL) {
				sonneFirst       = sunNew;
				sonneFirst->next = NULL;
        } else {
          if (sunNew->datum < sonneFirst->datum) {
            sunNew->next = sonneFirst;
            sonneFirst   = sunNew;
          } else {
            sonnePtr = sonneFirst;
            sunLast  = NULL;
            while ((sonnePtr->datum<sunNew->datum) && (sonnePtr->next!=NULL)) {
              sunLast  = sonnePtr;
              sonnePtr = sonnePtr->next;
            }
          }
				if (sonnePtr->datum < sunNew->datum) {
					sonnePtr->next = sunNew;
					sunNew->next   = NULL;
            } else {
					sunNew->next  = sonnePtr;
					sunLast->next = sunNew;
				}
			}
		}
	}
	Sun_RelZahl();
	Sonne_Liste(FALSE);
}

